
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

/* =============================================
	xvis user interface builder for Athena widgets using
	xv class library.

	ProjectList Segment

	V1.0BETA  - last edited 25/06/96
    ============================================= */

// ---------------------------------------------
// Include file declarations

#include "xvis.h"
#include <string.h>
#include <stdio.h>

int project_id[MAXPROJECTFILES+MAXEDITWINDOWS];
int selec=-1, CurrentModule=-1;

// ---------------------------------------------
// local forward function declares


// --------------------------------------------
// Callbacks

void func_projlist(Widget aw, XtPointer client, XtPointer call)
{
	XawListReturnStruct *val=XawListShowCurrent(projlist.ID());
	selec=val->list_index;
	if (selec==XAW_LIST_NONE) {
		CurrentModule=-1;
		projDelete.SetSensitive(FALSE);
		projOpen.SetSensitive(FALSE);
		xvisFileMenu.EntryResource("Save Module", XtNsensitive, FALSE);
	}
	else {
		CurrentModule=project_id[selec];		
		if (CurrentModule==-1) {
			projDelete.SetSensitive(FALSE);
			projOpen.SetSensitive(FALSE);
			xvisFileMenu.EntryResource("Save Module", XtNsensitive, FALSE);
		}
		else {
			projDelete.SetSensitive(TRUE);
			projOpen.SetSensitive(TRUE);
			xvisFileMenu.EntryResource("Save Module", XtNsensitive, TRUE);
		}
	}
}	

void proj_open(Widget aw, XtPointer client, XtPointer call)
{
	if (CurrentModule != -1) 
		if (module[CurrentModule].active)
			XtMapWidget(module[CurrentModule].editor->xvWindow::GetParent());
		else {
			module[CurrentModule].editor->xvWindow::Open();
			module[CurrentModule].active=TRUE;
		}
}

void func_p_yes(Widget aw, XtPointer client, XtPointer call)
{
	alert.Close();
	delete module[CurrentModule].editor;
	delete module[CurrentModule].edit_buffer;
	module[CurrentModule].in_use=FALSE;
	module[CurrentModule].first=TRUE;
	updateProjectListWindow();
	xvisFileMenu.EntryResource("Save Module", XtNsensitive, FALSE);
}

void func_p_no(Widget aw, XtPointer client, XtPointer call)
{
	alert.Close();
}

void proj_kill(Widget aw, XtPointer client, XtPointer call)
{
	alert.init("Delete...", xvisControl, 
		"Delete will destroy this object\nAre you sure you want to do this?",
		XVMSGSIMPLECHOICE, "green",
		func_p_yes, func_p_no);
	alert.Open();
}

//---------------------------------------------
// Local Stuff

void buildProjectListWindow()
{
	xvisProjList.init("Project", "xvisProjList", xvisContext);
	xvisProjList.SetBackground("gray85");
	xvisProjList.SetWindowResource(XtNgeometry, (XtArgVal)"-55-25");
	xvisProjList.SetWindowResource(XtNmaxWidth, 170);
	xvisProjList.SetWindowResource(XtNmaxHeight, 250);
	xvisProjList.SetWindowResource(XtNminWidth, 170);
	xvisProjList.SetWindowResource(XtNminHeight, 250);
	xvisProjList.SetWindowResource(XtNiconPixmap, xvisProjList.SetPixmapInfo(
		xvis_xpm, NULL));
	projview.init("projview", xvisProjList, TRUE, FALSE, TRUE);
	projview.SetFixedPosition(TRUE);
	
	projlist.init("projlist", projview, func_projlist, 0, projectlist, 1);
	projlist.SetWidth(160);
	projlist.SetHeight(200);
	projlist.ChangeFont("*fixed-*-r-*-140*");

	projOpen.init("Open", xvisProjList, proj_open);
	projOpen.SetShadowWidth(4);
	projOpen.SetRelVertical(projview);
	projOpen.SetSize(70, 30);
	projOpen.SetHorizDistance(10);
	projOpen.SetFixedPosition(TRUE);
	projOpen.ChangeFont("*fixed-*-r-*-120*");
	projOpen.SetBeNiceToColormap(FALSE);

	projDelete.init("Delete", xvisProjList, proj_kill);
	projDelete.SetShadowWidth(4);
	projDelete.SetRelVertical(projview);
	projDelete.SetSize(70, 30);
	projDelete.SetHorizDistance(90);
	projDelete.SetFixedPosition(TRUE);
	projDelete.ChangeFont("*fixed-*-r-*-120*");
	projDelete.SetBeNiceToColormap(FALSE);

	projDelete.SetSensitive(FALSE);
	projOpen.SetSensitive(FALSE);

	xvisProjList.Open();
	ProjectListVisible=TRUE;
}

// ---------------------------------

void updateProjectListWindow()
{
	if (! ProjectListVisible) return;

	num_proj=0;
	projectlist[0]=NULL;
	for (int i=0; i<MAXPROJECTFILES; i++) 
		if (project_list[i] != -1) {
			projectlist[num_proj]=objects[project_list[i]].name;
			project_id[num_proj++]=-1;
		}

	for (int i=0; i<MAXEDITWINDOWS; i++)
		if (module[i].in_use) {
			projectlist[num_proj]=module[i].name;	
			project_id[num_proj++]=i;
		}

	projlist.SetList(num_proj, projectlist);
	projlist.SetWidth(200);
	projlist.SetHeight(200);
}

// ---------------------------------------------
		